#include <iostream.h>
#include <sstream.h>
#define DLL_EXPORT
#include "processViewer.h"

class procSpy : public IProcSpy
{
public:
	~procSpy()
	{
		cout << "deconstructor" << endl;
		//delete this;
	}
	virtual bool showProcesses(PSENUMPROC_S cbkProc)
	{
		HANDLE snapshot = (0);
		snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
		if (snapshot == INVALID_HANDLE_VALUE) return false;
		PROCESSENTRY32 pe32;
		pe32.dwSize = sizeof(PROCESSENTRY32);
		if (!Process32First(snapshot, &pe32))
		{
			CloseHandle(snapshot);
			return false;
		}
		ostringstream oss;
		do
		{
			oss << pe32.szExeFile << ", PID = " << pe32.th32ProcessID;
			(*cbkProc)(oss.str());
			oss.str(std::string());
    		oss.seekp(0,std::ios_base::beg);
		} while (Process32Next(snapshot, &pe32));
		CloseHandle(snapshot);

		return true;
	}

	virtual void release()
	{
		cout << "release" << endl;
		delete this;
	}
};

IProcSpy* __stdcall CreateProcSpy()
{
	return new procSpy;
}